-- Table: "ExtTableDefinition"

DROP TABLE "ExtTableDefinition";

CREATE TABLE "ExtTableDefinition"
(
  "idExtTable" numeric NOT NULL,
  "idFieldName" varchar(50) NOT NULL,
  "codExtTable" varchar(20) NOT NULL,
  "tableDescription" varchar(100),
  version int8 DEFAULT 0,
  CONSTRAINT "ExtTableDefinition_pkey" PRIMARY KEY ("idExtTable")
) 
WITHOUT OIDS;
ALTER TABLE "ExtTableDefinition" OWNER TO "admin";


-- Table: "ExtFieldDefinition"

DROP TABLE "ExtFieldDefinition";

CREATE TABLE "ExtFieldDefinition"
(
  "idExtField" numeric NOT NULL,
  "idExtTable" numeric NOT NULL,
  "fieldType" numeric NOT NULL,
  "fieldLength" numeric(6,2),
  "fieldDescription" varchar(100),
  nullable bool,
  historizable bool,
  "codExtField" varchar(20) NOT NULL,
  version int8 DEFAULT 0,
  CONSTRAINT "ExtFieldDefinition_pkey" PRIMARY KEY ("idExtField"),
  CONSTRAINT "ExtFieldDefinition_idExtTable_fkey" FOREIGN KEY ("idExtTable")
      REFERENCES "ExtTableDefinition" ("idExtTable") MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
) 
WITHOUT OIDS;
ALTER TABLE "ExtFieldDefinition" OWNER TO "admin";


-- Table: "ExtFieldStringValue"

DROP TABLE "ExtFieldStringValue";

CREATE TABLE "ExtFieldStringValue"
(
  "idExtField" numeric NOT NULL,
  "idValue" numeric NOT NULL,
  value varchar,
  version int8 DEFAULT 0,
  CONSTRAINT "ExtFieldStringValue_pkey" PRIMARY KEY ("idExtField", "idValue")
) 
WITHOUT OIDS;
ALTER TABLE "ExtFieldStringValue" OWNER TO "admin";


-- Table: "ExtFieldLongValue"

DROP TABLE "ExtFieldLongValue";

CREATE TABLE "ExtFieldLongValue"
(
  "idExtField" numeric NOT NULL,
  "idValue" numeric NOT NULL,
  value oid,
  version int8 DEFAULT 0,
  CONSTRAINT "ExtFieldLongValue_pkey" PRIMARY KEY ("idExtField", "idValue")
) 
WITHOUT OIDS;
ALTER TABLE "ExtFieldLongValue" OWNER TO "admin";


-- Table: "ExtFieldNumberValue"

DROP TABLE "ExtFieldNumberValue";

CREATE TABLE "ExtFieldNumberValue"
(
  "idExtField" numeric NOT NULL,
  "idValue" numeric NOT NULL,
  value numeric,
  version int8 DEFAULT 0,
  CONSTRAINT "ExtFieldNumberValue_pkey" PRIMARY KEY ("idExtField", "idValue")
) 
WITHOUT OIDS;
ALTER TABLE "ExtFieldNumberValue" OWNER TO "admin";


-- Table: "ExtFieldDateValue"

DROP TABLE "ExtFieldDateValue";

CREATE TABLE "ExtFieldDateValue"
(
  "idExtField" numeric NOT NULL,
  "idValue" numeric NOT NULL,
  value timestamp,
  version int8 DEFAULT 0,
  CONSTRAINT "ExtFieldDateValue_pkey" PRIMARY KEY ("idExtField", "idValue")
) 
WITHOUT OIDS;
ALTER TABLE "ExtFieldDateValue" OWNER TO "admin";


-- Table: "ExtFieldBooleanValue"

DROP TABLE "ExtFieldBooleanValue";

CREATE TABLE "ExtFieldBooleanValue"
(
  "idExtField" numeric NOT NULL,
  "idValue" numeric NOT NULL,
  value bool,
  version int8 DEFAULT 0,
  CONSTRAINT "ExtFieldBooleanValue_pkey" PRIMARY KEY ("idExtField", "idValue")
) 
WITHOUT OIDS;
ALTER TABLE "ExtFieldBooleanValue" OWNER TO "admin";


-- Table: "AppResource"

DROP TABLE "AppResource";

CREATE TABLE "AppResource"
(
  "idResource" numeric NOT NULL,
  "codResource" varchar(50) NOT NULL,
  description varchar(100) NOT NULL,
  path varchar(250) NOT NULL,
  version int8 DEFAULT 0,
  CONSTRAINT "AppResource_pkey" PRIMARY KEY ("idResource")
) 
WITHOUT OIDS;
ALTER TABLE "AppResource" OWNER TO "admin";
