-- View: "vw_ext_item_values"

DROP VIEW "VW_EXT_ITEM_VALUES";

CREATE OR REPLACE VIEW "VW_EXT_ITEM_VALUES" ("idExtTable", "codExtTable", "idFieldName", "tableDescription",
	"idExtField", "codExtField", "fieldType", "fieldLength", "fieldDescription", "nullable", "historizable",
	"idValue", "strVal", "numVal", "datVal", "booVal", "lonVal") 
AS (
	select distinct t."idExtTable", t."codExtTable", t."idFieldName", t."tableDescription",
	f."idExtField", f."codExtField", f."fieldType", f."fieldLength", f."fieldDescription", f."nullable", f."historizable",
	v."idValue", v."value" as "strVal", NULL::numeric as "numVal", NULL::timestamp with time zone as "datVal", NULL::boolean as "booVal", NULL::oid as "lonVal"
	from "ExtTableDefinition" t, "ExtFieldDefinition" f, "ExtFieldStringValue" v
	where 	t."idExtTable" = f."idExtTable" and
		f."idExtField" = v."idExtField"

	union

	select distinct t."idExtTable", t."codExtTable", t."idFieldName", t."tableDescription",
	f."idExtField", f."codExtField", f."fieldType", f."fieldLength", f."fieldDescription", f."nullable", f."historizable",
	v."idValue", NULL as "strVal", v."value" as "numVal", NULL::timestamp with time zone as "datVal", NULL::boolean as "booVal", NULL::oid as "lonVal"
	from "ExtTableDefinition" t, "ExtFieldDefinition" f, "ExtFieldNumberValue" v
	where 	t."idExtTable" = f."idExtTable" and
		f."idExtField" = v."idExtField"

	union

	select distinct t."idExtTable", t."codExtTable", t."idFieldName", t."tableDescription",
	f."idExtField", f."codExtField", f."fieldType", f."fieldLength", f."fieldDescription", f."nullable", f."historizable",
	v."idValue", NULL as "strVal", NULL::numeric as "numVal", v."value" as "datVal", NULL::boolean as "booVal", NULL::oid as "lonVal"
	from "ExtTableDefinition" t, "ExtFieldDefinition" f, "ExtFieldDateValue" v
	where 	t."idExtTable" = f."idExtTable" and
		f."idExtField" = v."idExtField"


	union

	select distinct t."idExtTable", t."codExtTable", t."idFieldName", t."tableDescription",
	f."idExtField", f."codExtField", f."fieldType", f."fieldLength", f."fieldDescription", f."nullable", f."historizable",
	v."idValue", NULL as "strVal", NULL::numeric as "numVal", NULL::timestamp with time zone as "datVal", v."value" as "booVal", NULL::oid as "lonVal"
	from "ExtTableDefinition" t, "ExtFieldDefinition" f, "ExtFieldBooleanValue" v
	where 	t."idExtTable" = f."idExtTable" and
		f."idExtField" = v."idExtField"

	union

	select distinct t."idExtTable", t."codExtTable", t."idFieldName", t."tableDescription",
	f."idExtField", f."codExtField", f."fieldType", f."fieldLength", f."fieldDescription", f."nullable", f."historizable",
	v."idValue", NULL as "strVal", NULL::numeric as "numVal", NULL::timestamp with time zone as "datVal", NULL::boolean as "booVal", v."value" as "lonVal"
	from "ExtTableDefinition" t, "ExtFieldDefinition" f, "ExtFieldLongValue" v
	where 	t."idExtTable" = f."idExtTable" and
		f."idExtField" = v."idExtField"
);

ALTER TABLE "VW_EXT_ITEM_VALUES" OWNER TO admin;
