package com.imagos.axilice.client.gui;

import org.apache.log4j.Logger;
import com.imagos.axilice.client.gui.common.CommonClient;
import com.imagos.axilice.core.InterfaceAxilice;
import com.imagos.javaglade.Gui;
import com.imagos.javaglade.InterfaceGladeGtk;
import com.imagos.javaglade.JavaGladeException;
import com.imagos.javaglade.handlers.GenericHandler;
import com.imagos.javaglade.toolkit.swt.SwtDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

public class AxiliceValueInput extends GenericHandler {

	private String valueWidgetInputGUIName;
	private SwtDialog dialogValueInput;
	private Logger logger;
	private String value;
	private Text valueWidget;
//	private CommonClient entityLauncher;
	private Button okButton, cancelButton;
	private Gui parentGui;
	private String selectedMethod;
	private GenericHandler selectedListener;
	
	
	//public AxiliceValueInput() {
	//	super();
		
	//}
	
	public AxiliceValueInput(Logger log, Gui parentGui, String selectedMethod, GenericHandler selectedListener){
		super();
		this.logger=log;
		this.value = null;
		this.valueWidgetInputGUIName = parentGui.getGuiName() + "\\"
		+ "Axilice_ValueInput";
		this.parentGui = parentGui;
		this.selectedMethod = selectedMethod;
		this.selectedListener = selectedListener;
	}
	
	public void build(){
		try {
			this.gui = AxiliceGUIBuilder.getInstance().buildGUI(
					valueWidgetInputGUIName,
					InterfaceAxilice.AXILICE_VALUE_INPUT_GLADE_PATH,
					parentGui,
					parentGui.getParentWindow());

			getWidgets();
			Listener[] list=cancelButton.getListeners(SWT.Selection);
			for (Listener l:list){
				cancelButton.removeListener(SWT.Selection, l);
				
			}
			Listener[] list2=okButton.getListeners(SWT.Selection);
			for (Listener l:list2){
				okButton.removeListener(SWT.Selection, l);
				
			}
			AxiliceGUIBuilder.getInstance().connectSignal(InterfaceGladeGtk.GTK_SIGNAL_TYPE_CLICKED, cancelButton, "on_cancel_button_clicked", this);
			AxiliceGUIBuilder.getInstance().connectSignal(InterfaceGladeGtk.GTK_SIGNAL_TYPE_CLICKED, okButton, "on_ok_button_clicked", this);
			AxiliceGUIBuilder.getInstance().connectSignal(InterfaceGladeGtk.GTK_SIGNAL_TYPE_CLICKED, okButton, this.selectedMethod, this.selectedListener);
			
			this.dialogValueInput.getShell().setDefaultButton(okButton);

		} catch (JavaGladeException e) {
			logger.error("Error building Map Dialog");
			e.printStackTrace();

		}
		
	}
	
	
	private void getWidgets(){
		if (this.gui != null){
			valueWidget=(Text)this.gui.getWidget(InterfaceAxilice.VALUE_INPUT_VALUE_WIDGETNAME);
			dialogValueInput = this.gui.getDialog(
					InterfaceAxilice.AXILICE_VALUE_INPUT_DIALOG_NAME);
			okButton=(Button)this.gui.getWidget(InterfaceAxilice.VALUE_INPUT_OK_BUTTON_WIDGETNAME);
			cancelButton=(Button)this.gui.getWidget(InterfaceAxilice.VALUE_INPUT_CANCEL_BUTTON_WIDGETNAME);
		}
		if (valueWidget== null || dialogValueInput==null || okButton==null || cancelButton==null)
			System.exit(-1);
	}
	
	
	public void show(String value){
		valueWidget.setText(value);
		dialogValueInput.open();
	}
	
	
	public void on_cancel_button_clicked(Event e){
		this.value = null;
		dialogValueInput.close();
	}
	
	public void on_ok_button_clicked(Event e){
		this.value = valueWidget.getText();
		System.out.println("Introducido nuevo valor..." + getValue());
		dialogValueInput.close();

	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}
}
