package com.imagos.axilice.client.gui.common;

import java.util.HashSet;

import com.imagos.axilice.client.gui.AxiliceGUIBuilder;
import com.imagos.axilice.core.InterfaceAxilice;
import com.imagos.axilice.core.common.BaseVO;
import com.imagos.axilice.core.common.MultiSelectionSubentityOT;
import com.imagos.axilice.core.common.PriceListLineOT;
import com.imagos.axilice.core.common.PriceListOT;
import com.imagos.axilice.core.common.SelectionSubentityOT;
import com.imagos.axilice.core.util.Converter;
import com.imagos.axilice.core.util.OperationResult;
import com.imagos.axilice.core.warehouse.InterfaceWarehouse;
import com.imagos.axilice.core.warehouse.ProductOT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Text;

/**
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 * 
 * <br>
 * <br>
 *         This program is free software: you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation, either version 3 of the License, or (at
 *         your option) any later version. <br/>
 *         This program is distributed in the hope that it will be useful, but
 *         WITHOUT ANY WARRANTY 
 *         <br>without even the implied warranty of
 *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *         General Public License for more details. <br/>
 *         You should have received a copy of the GNU General Public License
 *         along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
public class PriceListLineClient extends CommonClient {

	protected Text entryPriceListLineId, entryPriceListLineProduct,
			entryPriceListLineDisccount, entryPriceListLinePrice,
			entryPriceListLinePriceList;

	protected Button buttonSelectProduct, buttonSelectPriceList;

	protected Button saveButton, cancelButton, undoButton;

	public PriceListLineClient() {
		super(	PriceListLineOT.class, 
				InterfaceAxilice.AXILICE_EDIT_PRICELISTLINE_GLADE_PATH,
				InterfaceAxilice.AXILICE_PRICELISTLINE_DIALOG_NAME);
	}

	@Override
	public void clearEntityData() {
		PriceListLineOT pll = new PriceListLineOT();
		if (isDetail()) {
			if (this.entityDetailView.getSubentityData().getParentEntity().getEntity().getKey()
					.equals(InterfaceAxilice.AXILICE_ENTITY_PRICELIST_ID)) {
				PriceListOT parentPriceList = (PriceListOT) entityDetailView
						.getSubentityData().getParentEntity()
						.getSelectedEntity();
				pll.setPriceList(parentPriceList);
				entryPriceListLinePriceList.setEnabled(false);
				buttonSelectPriceList.setEnabled(false);
			}
			
			if (this.entityDetailView.getSubentityData().getParentEntity().getEntity().getKey()
					.equals(InterfaceWarehouse.AXILICE_ENTITY_PRODUCT_ID)) {
				ProductOT parentProduct = (ProductOT) entityDetailView
						.getSubentityData().getParentEntity().getSelectedEntity();
				pll.setProduct(parentProduct);
				entryPriceListLineProduct.setEnabled(false);
				buttonSelectProduct.setEnabled(false);
			}
		}

		setWidgetsValues(pll);
	}

	@Override
	public void buildSelectionSets(){
		lSelectionSubentities=new HashSet<SelectionSubentityOT>();
		lSelectionSubentities.add(new SelectionSubentityOT(InterfaceWarehouse.AXILICE_ENTITY_PRODUCT_ID
				, InterfaceAxilice.EDIT_PRICELISTLINE_PRODUCT_WIDGETNAME, this, buttonSelectProduct));
		lSelectionSubentities.add(new SelectionSubentityOT(InterfaceAxilice.AXILICE_ENTITY_PRICELIST_ID
				, InterfaceAxilice.EDIT_PRICELISTLINE_PRICELIST_WIDGETNAME, this, buttonSelectPriceList));
		
		lMultiSelectionSubentities=new HashSet<MultiSelectionSubentityOT>();
		
	}
	
	@Override
	public BaseVO getEntityData() {
		PriceListLineOT entity = new PriceListLineOT();
		if (this.entEditView != null) {
			entity.setPrice(Converter.getInstance().parseBigDecimal(
					entryPriceListLinePrice.getText()));
			entity.setDisccount((Converter.getInstance()
					.parseFloat(entryPriceListLineDisccount.getText())));
			entity.setProduct((ProductOT) entryPriceListLineProduct.getData());
			entity.setPriceList((PriceListOT) entryPriceListLinePriceList
					.getData());

			if (selectedEntity != null) {
				entity.setVersion(((PriceListLineOT) this.selectedEntity).getVersion());
				entity.setIdPriceListLine(((PriceListLineOT) this.selectedEntity).getIdPriceListLine());
			}
		}

		return entity;
	}

	@Override
	public OperationResult validateEntity() {
		// TODO Auto-generated method stub
		return null;
	}



	@Override
	public void getWidgets() {
		boolean allOk = true;

		saveButton = (Button) this.entEditView.getGui().getWidget(
				InterfaceAxilice.AXILICE_ENTITYEDITION_SAVE_BUTTON_NAME);

		undoButton = (Button) this.entEditView.getGui().getWidget(
				InterfaceAxilice.AXILICE_ENTITYEDITION_UNDO_BUTTON_NAME);

		cancelButton = (Button) this.entEditView.getGui().getWidget(
				InterfaceAxilice.AXILICE_ENTITYEDITION_CANCEL_BUTTON_NAME);

		if ((entryPriceListLineId = ((Text) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISLILNE_CODE_WIDGETNAME))) == null)	{
			allOk=false;
			fireExceptionAndExit("Error widget "+InterfaceAxilice.EDIT_PRICELIST_CODE_WIDGETNAME);
		}

		if ((entryPriceListLineProduct = ((Text) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISTLINE_PRODUCT_WIDGETNAME))) == null) {
			allOk=false;
			fireExceptionAndExit("Error widget "+InterfaceAxilice.EDIT_PRICELISTLINE_PRODUCT_WIDGETNAME);
		}
		if ((entryPriceListLinePrice = (Text) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISTLINE_PRICE_WIDGETNAME)) == null){
			allOk=false;
			fireExceptionAndExit("Error widget "+InterfaceAxilice.EDIT_PRICELISTLINE_PRICE_WIDGETNAME);
		}
		if ((entryPriceListLineDisccount = (Text) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISTLINE_DISCOUNT_WIDGETNAME)) == null) {
			allOk=false;
			fireExceptionAndExit("Error widget " + InterfaceAxilice.EDIT_PRICELISTLINE_DISCOUNT_WIDGETNAME);
		}

		if ((entryPriceListLinePriceList = (Text) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISTLINE_PRICELIST_WIDGETNAME)) == null) {
			allOk=false;
			fireExceptionAndExit("Error widget "+InterfaceAxilice.EDIT_PRICELISTLINE_PRICELIST_WIDGETNAME);
		}

		if ((buttonSelectPriceList = (Button) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISTLINE_SELECT_PRICELIST_BUTTON_WIDGETNAME)) == null) {
			allOk=false;
			fireExceptionAndExit("Error widget "+InterfaceAxilice.EDIT_PRICELISTLINE_SELECT_PRICELIST_BUTTON_WIDGETNAME);
		}

		if ((buttonSelectProduct = (Button) this.entEditView.getGui().getWidget(
						InterfaceAxilice.EDIT_PRICELISTLINE_SELECT_PRODUCT_BUTTON_WIDGETNAME)) == null) {
			allOk=false;
			fireExceptionAndExit("Error widget "+InterfaceAxilice.EDIT_PRICELISTLINE_SELECT_PRODUCT_BUTTON_WIDGETNAME);
		}
	}

	@Override
	public void setEditionMode(boolean enabled) {
		entryPriceListLineDisccount.setEnabled(enabled);
		entryPriceListLineId.setEnabled(false);
		entryPriceListLinePrice.setEnabled(enabled);
		entryPriceListLinePriceList.setEnabled(enabled);
		entryPriceListLineProduct.setEnabled(enabled);
		buttonSelectPriceList.setEnabled(enabled);
		buttonSelectProduct.setEnabled(enabled);
		undoButton.setEnabled(enabled);
		cancelButton.setEnabled(enabled);
		saveButton.setEnabled(enabled);
		if (isDetail()) {
			if (this.entityDetailView.getSubentityData().getParentEntity().getEntity().getKey()
					.equals(InterfaceAxilice.AXILICE_ENTITY_PRICELIST_ID)) {
				entryPriceListLinePriceList.setEnabled(false);
				buttonSelectPriceList.setEnabled(false);
			}
			
			if (this.entityDetailView.getSubentityData().getParentEntity().getEntity().getKey()
					.equals(InterfaceWarehouse.AXILICE_ENTITY_PRODUCT_ID)) {
				entryPriceListLineProduct.setEnabled(false);
				buttonSelectProduct.setEnabled(false);
			}
		}

	}

	public void setWidgetsValues(BaseVO entity) {
		PriceListLineOT ent = (PriceListLineOT) entity;
		entryPriceListLineId.setText(Converter.getInstance().toString(
				ent.getIdPriceListLine()));
		entryPriceListLinePrice.setText(Converter.getInstance().toString(
				ent.getPrice()));
		entryPriceListLineDisccount.setText(Converter.getInstance().toString(
				ent.getDisccount()));

		if (ent.getProduct() != null) {
			entryPriceListLineProduct
					.setText(ent.getProduct().getDescription());
			entryPriceListLineProduct.setData(ent.getProduct());
		}
		else{
			entryPriceListLineProduct.setText("");
			entryPriceListLineProduct.setData(null);
		}
		
		if (ent.getPriceList() != null) {
			entryPriceListLinePriceList.setText(ent.getPriceList()
					.getDescription());
			entryPriceListLinePriceList.setData(ent.getPriceList());
		}
		else{
			entryPriceListLinePriceList.setText("");
			entryPriceListLinePriceList.setData(null);
		}
	}
	
	@Override
	public void fillEntityData() {
		PriceListLineOT ent = (PriceListLineOT) this.getSelectedEntity();
		entryPriceListLineId.setText(Converter.getInstance().toString(
				ent.getIdPriceListLine()));
		entryPriceListLinePrice.setText(Converter.getInstance().toString(
				ent.getPrice()));
		entryPriceListLineDisccount.setText(Converter.getInstance().toString(
				ent.getDisccount()));

		if (ent.getProduct() != null) {
			entryPriceListLineProduct
					.setText(ent.getProduct().getDescription());
			entryPriceListLineProduct.setData(ent.getProduct());
		}
		else{
			entryPriceListLineProduct.setText("");
			entryPriceListLineProduct.setData(null);
		}
		
		if (ent.getPriceList() != null) {
			entryPriceListLinePriceList.setText(ent.getPriceList()
					.getDescription());
			entryPriceListLinePriceList.setData(ent.getPriceList());
		}
		else{
			entryPriceListLinePriceList.setText("");
			entryPriceListLinePriceList.setData(null);
		}
	}

	@Override
	public void init_specific_components() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void build_extension_fields_view() {
		// TODO Auto-generated method stub
		
	}
}
