package com.imagos.axilice.client.partners;

import com.imagos.axilice.client.gui.common.CommonClient;
import com.imagos.axilice.core.common.BaseVO;
import com.imagos.axilice.core.partners.ContactOT;
import com.imagos.axilice.core.partners.InterfacePartners;
import com.imagos.axilice.core.partners.PartnerGroupOT;
import com.imagos.axilice.core.util.Converter;
import com.imagos.axilice.core.util.OperationResult;
import org.eclipse.swt.widgets.Text;


/**
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 * 
 * <br>
 * <br>
 *         This program is free software: you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation, either version 3 of the License, or (at
 *         your option) any later version. <br/>
 *         This program is distributed in the hope that it will be useful, but
 *         WITHOUT ANY WARRANTY 
 *         <br>without even the implied warranty of
 *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *         General Public License for more details. <br/>
 *         You should have received a copy of the GNU General Public License
 *         along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
public class PartnerGroupClient extends CommonClient {

	private Text entryCode, entryName;
	
	
	public PartnerGroupClient() {
		super(PartnerGroupOT.class, InterfacePartners.AXILICE_EDIT_PARTNERGROUP_GLADE_PATH,InterfacePartners.AXILICE_EDIT_PARTNERGROUP_DIALOG_NAME);
	}



	@Override
	public BaseVO getEntityData() {
		PartnerGroupOT dep=new PartnerGroupOT();
		if (this.entEditView!=null){
			dep.setDescription( entryName.getText());
		}
		if (selectedEntity!=null){
			dep.setVersion(((PartnerGroupOT)this.selectedEntity).getVersion());
			dep.setIdPartnerGroup(((PartnerGroupOT)this.selectedEntity).getIdPartnerGroup());
		}
		return dep;
	}





	@Override
	public OperationResult validateEntity() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setWidgetsValues(BaseVO entity) {
		PartnerGroupOT pg = (PartnerGroupOT)entity;
		entryCode.setText(Converter.getInstance().toString(pg.getIdPartnerGroup()));
		entryName.setText(Converter.getInstance().toString(pg.getDescription()));
		
	}

	@Override
	public void getWidgets() {
	
		int allOk = 0;
		// Entries
		entryCode = (Text) this.getWidget(
				InterfacePartners.EDIT_PARTNERGROUP_CODE_WIDGETNAME);
		if (entryCode == null)
			allOk = 1;
		entryName = (Text) this.getWidget(
				InterfacePartners.EDIT_PARTNERGROUP_DESCRIPTION_WIDGETNAME);
		if (entryName == null)
			allOk = 2;
		
		if (allOk != 0) {
			// this.logger.fatal("Error getting widgets");
			this.logger.debug("Error getting widget #" + allOk);
			fireExceptionAndExit("Error obtentiendo widgets");
		}
	}

	@Override
	public void buildSelectionSets() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setEditionMode(boolean enabled) {
		this.getWidgets();
		entryCode.setEnabled(false);
		entryName.setEnabled(enabled);
		
	}

	@Override
	public void init_specific_components() {
		// TODO Auto-generated method stub
		
	}



	@Override
	public void build_extension_fields_view() {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void fillEntityData() {
		if (this.selectedEntity != null && this.entEditView != null) {
			getWidgets();
			setWidgetsValues((PartnerGroupOT) selectedEntity);
		}
	}

}
