/*
 * WarehouseClient.java
 *
 * $Id: ProductStockClient.java,v 1.1 2009-10-07 10:19:31 mario Exp $
 */
package com.imagos.axilice.client.warehouse;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.HashSet;

import com.imagos.axilice.client.ClientContext;
import com.imagos.axilice.client.gui.AxiliceDateSelect;
import com.imagos.axilice.client.gui.AxiliceDetailEntityView;
import com.imagos.axilice.client.gui.AxiliceGUIBuilder;
import com.imagos.axilice.client.gui.common.CommonClient;
import com.imagos.axilice.core.AxiliceException;
import com.imagos.axilice.core.InterfaceAxilice;
import com.imagos.axilice.core.common.BaseVO;
import com.imagos.axilice.core.common.MultiSelectionSubentityOT;
import com.imagos.axilice.core.common.RegistryOT;
import com.imagos.axilice.core.common.SelectionSubentityOT;
import com.imagos.axilice.core.partners.AddressOT;
import com.imagos.axilice.core.partners.InterfacePartners;
import com.imagos.axilice.core.util.Converter;
import com.imagos.axilice.core.util.OperationResult;
import com.imagos.axilice.core.warehouse.InterfaceWarehouse;
import com.imagos.axilice.core.warehouse.ProductGroupOT;
import com.imagos.axilice.core.warehouse.ProductStockOT;
import com.imagos.axilice.core.warehouse.ProductOT;
import com.imagos.axilice.core.warehouse.WarehouseManager;
import com.imagos.javaglade.Gui;
import com.imagos.javaglade.InterfaceGladeGtk;
import com.imagos.javaglade.toolkit.swt.SwtWidget;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolItem;

public class ProductStockClient extends CommonClient {
	/**
     * Message for logging the entity glade configuration file path.
     */
    public static final String AXILICE_LOG_EDITSTOCK_GLADEPATH = "The stock edition interface configuration file has been found at this path: %s";
    
    public ProductStockClient() {
    	super(	ProductStockOT.class,
				InterfaceWarehouse.AXILICE_EDIT_STOCK_GLADE_PATH,
				InterfaceWarehouse.EDIT_STOCK_DIALOG_NAME);
    }
	
    @Override
	public ArrayList getEntityFields() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void fillEntityData() {
	}

	@Override
	public void clearEntityData() {
	}

	@Override
	public BaseVO getEntityData() {
		return null;
	}

	@Override
	public void updateEntityData() {
	}

	@Override
	public void setEditionMode(boolean enabled) {

	}
	
	@Override
	public void build_extension_fields_view() {
	}

	@Override
	public void buildSelectionSets() {
	}

	@Override
	public void getWidgets() {
	}

	@Override
	public void init_specific_components() {
		this.entEditView.dispose();
		this.entEditView = null;

		// Disable the add, view and edit entity buttons
		Gui entGui = this.entView.getGui();
		((Control)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_ADD_NAME)).setEnabled(false);
		((Control)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_EDIT_NAME)).setEnabled(false);
		((Control)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_VIEW_NAME)).setEnabled(false);
	}

	@Override
	public void setWidgetsValues(BaseVO entity) {
	}

	@Override
	public OperationResult validateEntity() {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public AxiliceDetailEntityView buildEntity(SwtWidget parent,
			MultiSelectionSubentityOT subentityData, String rootName) {
		this.entityDetailView = super.buildEntity(parent, subentityData, rootName);
		this.entView = null;
		
//		this.entEditView.dispose();
//		this.entEditView = null;

		// Disable the add, view and edit entity buttons
		Gui entGui = this.entityDetailView.getGui();
		((ToolItem)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_ADD_NAME)).setEnabled(false);
		((ToolItem)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_EDIT_NAME)).setEnabled(false);
		((ToolItem)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_VIEW_NAME)).setEnabled(false);
		((ToolItem)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_SELECT_NAME)).setEnabled(false);
		((ToolItem)entGui.getWidget(InterfaceAxilice.AXILICE_ENTITY_TOOLITEM_DEL_NAME)).setEnabled(false);
		
		return this.entityDetailView;
	}

	/**
	 * Returns tag Id assigned to CVS source file.
	 */
	public static String getRevision() {
		return "$Id: ProductStockClient.java,v 1.1 2009-10-07 10:19:31 mario Exp $";
	}
}
