/*
 * InterfaceExtTable.java
 *
 * $Id: InterfaceErrors.java,v 1.14 2009-07-17 11:15:31 juancarlos Exp $
 *
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 */
package com.imagos.axilice.core;

/**
 * Public interface with the constant definitions of error codes
 * returned by the application.
 */
public interface InterfaceErrors {
	// General errors
	public static final int ERR_NO_DB_CONNECTION = 1;
	public static final int ERR_NO_DB_ACCESS = 2;
	public static final int ERR_NO_SYNC = 3;
	public static final int ERR_DB_QUERY_ERROR = 4;
	public static final int ERR_DB_CONSTRAINT_VIOLATION = 5;
	public static final int ERR_GUI_OPERATION_ERROR = 6;
	
	public static final int ERR_RMI_NO_ACCESS = 11;
	public static final int ERR_RMI_NOT_BOUND = 12;
	public static final int ERR_RMI_METHOD_NOT_FOUND = 13;
	
	// Errors thrown during extension tables' operations
	public static final int ERR_NO_EXT_TABLE_FOUND = 101;
	public static final int ERR_NO_EXT_FIELD_FOUND = 102;
	public static final int ERR_NO_EXT_ITEM_FOUND = 103;
	public static final int ERR_INCORRECT_EXT_FIELD_TYPE = 104;
	public static final int ERR_INCORRECT_EXT_FIELD_LENGTH = 105;
	public static final int ERR_EXT_FIELD_LIST_EMPTY = 106;
	public static final int ERR_DELETE_NON_EXISTENT_EXT_TABLE = 107;
	public static final int ERR_DELETE_NON_EXISTENT_EXT_FIELD = 108;
	public static final int ERR_SAVE_NULL_EXT_TABLE	 = 109;
	public static final int ERR_SAVE_NULL_EXT_FIELD	 = 110;
	public static final int ERR_SAVE_EXT_FIELD_WITH_NULL_EXT_TABLE	 = 111;
	public static final int MSG_SAVE_EXT_VALUES_OK	 = 112;

	// Errors thrown during application resources' installation operations
	public static final int ERR_RESOURCE_NOT_FOUND = 201;
	public static final int ERR_RESOURCE_NOT_LOADED = 202;
	public static final int ERR_RESOURCE_TOO_LARGE = 203;
	public static final int ERR_RESOURCE_INCORRECT_TYPE = 204;
	public static final int ERR_RESOURCE_INCORRECT_VERSION = 205;
	public static final int ERR_RESOURCE_INCORRECT_PATH = 206;
	public static final int ERR_RESOURCE_NOT_WRITTEN = 207;
	public static final int ERR_RESOURCE_UPDATE_CATALOG = 208;

	public static final int ERR_RESOURCE_NULL_CLASSPATH = 209;
	public static final int ERR_RESOURCE_MALFORMED_CLASSPATH = 210;
	public static final int ERR_RESOURCE_NULL_PATHSEPARATOR = 211;
	public static final int ERR_RESOURCE_NULL_FILESEPARATOR = 212;
	public static final int ERR_RESOURCE_INCORRECT_DIRECTORY = 213;
	
	public static final int ERR_AREA_NOT_FOUND = 214;
	
	// Errors thrown during traceability file parsing
    public static final int ERR_TRACEABILITY_PARSING_EMPTY_TAG = 301;
    public static final int ERR_TRACEABILITY_PARSING_UNKNOWN_TAG = 302;
    public static final int ERR_TRACEABILITY_PARSING_UNEXPECTED_TAG = 303;
    public static final int ERR_TRACEABILITY_PARSING_GENERAL_ERROR = 304;
    public static final int ERR_TRACEABILITY_PARSING_INCORRECT_ITINERARY = 305;
    
	// Errors thrown during image operations
    public static final int MSG_IMAGE_SAVE_OK = 321;
    public static final int ERR_IMAGE_SAVE_ERROR = 322;
    public static final int ERR_IMAGE_SAVE_NO_WRITE_PERMISSIONS = 323;
    
    public static final int MSG_IMAGE_DELETE_OK = 324;
    public static final int ERR_IMAGE_DELETE_ERROR = 325;
    public static final int ERR_IMAGE_DELETE_NO_WRITE_PERMISSIONS = 326;
    
    // Entity delete cancelled message code
    public static final int MSG_DELETE_ENTITY_CANCELLED = 331;
    
    
    // Barcode type search messages
	public static final int ERR_BARCODETYPE_NOT_FOUND = 401;
	public static final int ERR_BARCODETYPE_ID_NOT_FOUND = 402;
	// Barcode type delete messages
	public static final int MSG_BARCODETYPE_DELETE_OK = 403;
	public static final int ERR_BARCODETYPE_DELETE = 404;
	public static final int ERR_BARCODETYPE_DELETE_NULL = 405;
	public static final int MSG_BARCODETYPE_DELETE_CANCELLED = 406;
	// Barcode type save messages
	public static final int MSG_BARCODETYPE_SAVE_OK = 407;
	public static final int ERR_BARCODETYPE_SAVE= 408;
	public static final int ERR_BARCODETYPE_SAVE_NULL = 409;
	
    // VAT type search messages
	public static final int ERR_VATTYPE_NOT_FOUND = 421;
	public static final int ERR_VATTYPE_ID_NOT_FOUND = 422;
	// VAT type delete messages
	public static final int MSG_VATTYPE_DELETE_OK = 423;
	public static final int ERR_VATTYPE_DELETE = 424;
	public static final int ERR_VATTYPE_DELETE_NULL = 425;
	public static final int MSG_VATTYPE_DELETE_CANCELLED = 426;
	// VAT type save messages
	public static final int MSG_VATTYPE_SAVE_OK = 427;
	public static final int ERR_VATTYPE_SAVE= 428;
	public static final int ERR_VATTYPE_SAVE_NULL = 429;
	
    // Address search messages
	public static final int ERR_ADDRESS_NOT_FOUND = 441;
	public static final int ERR_ADDRESS_ID_NOT_FOUND = 442;
	// Address delete messages
	public static final int MSG_ADDRESS_DELETE_OK = 443;
	public static final int ERR_ADDRESS_DELETE = 444;
	public static final int ERR_ADDRESS_DELETE_NULL = 445;
	public static final int MSG_ADDRESS_DELETE_CANCELLED = 446;
	// Address save messages
	public static final int MSG_ADDRESS_SAVE_OK = 447;
	public static final int ERR_ADDRESS_SAVE= 448;
	public static final int ERR_ADDRESS_SAVE_NULL = 449;
	
	
	//VALIDATION MESSAGES
	public static final int MSG_VALIDATE_OK = 450;
	public static final int MSG_VALIDATE_ERROR = 451;
	
	public static final int ERR_EDIT_ENTITY = 452;
	public static final int MSG_EDIT_ENTITY_OK = 453;
	
	public static final int MSG_EMAIL_VALIDATION_ERROR = 454;
	public static final int MSG_PHONE_VALIDATION_ERROR = 455;
	public static final int MSG_ENTITY_RETRIVE_OK = 456;
	
	public static final int ERR_DELETE_ENTITY_NULL = 457;
	public static final int MSG_DELETE_ENTITY_OK = 458;
	public static final int ERR_DELETE_ENTITY = 459;
	public static final int ERR_ENTITY_NOT_FOUND = 460;
	public static final int ERR_SAVE_ENTITY_NULL = 461;
	public static final int MSG_SAVE_ENTITY_OK = 462;
	public static final int ERR_SAVE_ENTITY = 463;
	public static final int ERR_HIBERNATE_OPENING_SESSION = 464;
	
	
	public static final int MSG_MAP_OK = 465;
	public static final int ERR_MAP_ERROR = 466;
	public static final int ERR_NULL_ENTITY_LAUNCHER_ON_VIEW = 467;
	public static final int ERR_JASPER_FILE_NOT_FOUND = 468;
	public static final int ERR_JASPERREPORTS_EXCEPTION = 469;
	public static final int MSG_REPORT_OK = 470;
	public static final int ERR_MAP_GEOCODING_ERROR = 471;
	public static final int ERR_MAP_URL_ERROR = 472;
	public static final int ERR_MAP_IO_ERROR = 473;
	public static final int ERR_MAP_PARSE_ERROR = 474;
}

