/*
 * ExtFieldBooleanValueOT.java
 * 
 * $Id: ExtFieldBooleanValueOT.java,v 1.1 2008-03-18 12:58:45 mario Exp $
 * 
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 */
package com.imagos.axilice.core.extTables;

import java.io.Serializable;

/**
 * Store class to hold the data of a Boolean type extension field's value. 
 * It keeps the value of the extension field defined for an extended item.
 * <br/>
 * Responsibilities:
 * <li>
 * 	<ul> Store of extension data for exchanging data among presentation, 
 * business and data access layers. </ul>
 * </li>
 */
public class ExtFieldBooleanValueOT extends ExtFieldValueOT implements Serializable {
	/**
	 * Boolean value of the extension field for the extended item.
	 */
	private Boolean value;
	
	private static final long serialVersionUID = 10000003;
	
	public Boolean getValue() {
		return value;
	}

	public void setValue(Boolean value) {
		this.value = value;
	}

	/**
	 * Returns tag Id assigned to CVS source file.
	 */
	public static String getRevision() {
		return "$Id: ExtFieldBooleanValueOT.java,v 1.1 2008-03-18 12:58:45 mario Exp $";
	}
}
