/*
 * ExtFieldDateValueOT.java
 * 
 * $Id: ExtFieldDateValueOT.java,v 1.2 2009-09-17 12:11:26 mario Exp $
 * 
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 */
package com.imagos.axilice.core.extTables;

import java.io.Serializable;
import java.sql.Date;
import java.sql.Timestamp;

/**
 * Store class to hold the data of a Date type extension field's value. 
 * It keeps the value of the extension field defined for an extended item.
 * <br/>
 * Responsibilities:
 * <li>
 * 	<ul> Store of extension data for exchanging data among presentation, 
 * business and data access layers. </ul>
 * </li>
 */
public class ExtFieldDateValueOT extends ExtFieldValueOT implements Serializable {
	/**
	 * Date value of the extension field for the extended item.
	 */
	private Date value;
	
	private static final long serialVersionUID = 10000003;
	
	public Date getValue() {
		return value;
	}

	public void setValue(Date value) {
		this.value = value;
	}

	/**
	 * Returns tag Id assigned to CVS source file.
	 */
	public static String getRevision() {
		return "$Id: ExtFieldDateValueOT.java,v 1.2 2009-09-17 12:11:26 mario Exp $";
	}
}
