/*
 * ExtFieldLongValueOT.java
 * 
 * $Id: ExtFieldLongValueOT.java,v 1.1 2009-03-02 15:31:23 mario Exp $
 * 
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 */
package com.imagos.axilice.core.extTables;

import java.io.Serializable;

/**
 * Store class to hold the data of a Long (BLOB) type extension field's value. 
 * It keeps the value of the extension field defined for an extended item.
 * <br/>
 * Responsibilities:
 * <li>
 * 	<ul> Store of extension data for exchanging data among presentation, 
 * business and data access layers. </ul>
 * </li>
 */
public class ExtFieldLongValueOT extends ExtFieldValueOT implements Serializable {
	/**
	 * Long value of the extension field for the extended item.
	 */
	private byte[] value;
	
	private static final long serialVersionUID = 10000003;
	
	public byte[] getValue() {
		return value;
	}

	public void setValue(byte[] value) {
		this.value = value;
	}

	/**
	 * Returns tag Id assigned to CVS source file.
	 */
	public static String getRevision() {
		return "$Id: ExtFieldLongValueOT.java,v 1.1 2009-03-02 15:31:23 mario Exp $";
	}
}
