/*
 * ExtFieldNumberValueOT.java
 * 
 * $Id: ExtFieldNumberValueOT.java,v 1.1 2008-03-18 12:58:45 mario Exp $
 * 
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 */
package com.imagos.axilice.core.extTables;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * Store class to hold the data of a String type extension field's value. 
 * It keeps the value of the extension field defined for an extended item.
 * <br/>
 * Responsibilities:
 * <li>
 * 	<ul> Store of extension data for exchanging data among presentation, 
 * business and data access layers. </ul>
 * </li>
 */
public class ExtFieldNumberValueOT extends ExtFieldValueOT implements Serializable {
	/**
	 * BigDecimal (Numeric) value of the extension field for the extended item.
	 */
	private BigDecimal value;
	
	private static final long serialVersionUID = 10000004;
	
	public BigDecimal getValue() {
		return value;
	}

	public void setValue(BigDecimal value) {
		this.value = value;
	}

	/**
	 * Returns tag Id assigned to CVS source file.
	 */
	public static String getRevision() {
		return "$Id: ExtFieldNumberValueOT.java,v 1.1 2008-03-18 12:58:45 mario Exp $";
	}
}
