
package com.imagos.axilice.core.partners;


/**
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 * 
 * <br>
 * <br>
 *         This program is free software: you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation, either version 3 of the License, or (at
 *         your option) any later version. <br/>
 *         This program is distributed in the hope that it will be useful, but
 *         WITHOUT ANY WARRANTY 
 *         <br>without even the implied warranty of
 *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *         General Public License for more details. <br/>
 *         You should have received a copy of the GNU General Public License
 *         along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
public class InterfacePartners {
	
	
	// PATH TO THE GLADE FILES
	public static final String AXILICE_EDIT_DEPARTMENT_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicedepartment.glade";
	public static final String AXILICE_EDIT_RAPPELTYPE_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicerappeltype.glade";
	public static final String AXILICE_EDIT_RAPPELINTERVAL_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicerappelinterval.glade";
	public static final String AXILICE_EDIT_PARTNER_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicepartner.glade";
	public static final String AXILICE_EDIT_RATE_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicerate.glade";
	public static final String AXILICE_EDIT_PARTNERGROUP_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicepartnergroup.glade";
	public static final String AXILICE_EDIT_VENDOR_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicevendor.glade";
	public static final String AXILICE_EDIT_CONTACT_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicecontact.glade";
	public static final String AXILICE_VIEW_MAP_GLADE_PATH = "/com/imagos/axilice/client/gui/common/axilicemap.glade";
	public static final String AXILICE_ENTITY_GLADE_PATH ="/com/imagos/axilice/client/gui/axilicepartnersentity.glade";
	public static final String AXILICE_ENTITY_DETAIL_GLADE_PATH ="/com/imagos/axilice/client/gui/axilicepartnersentitydetail.glade";
	public static final String AXILICE_EDIT_DISCOUNT_TABLE_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicediscounttable.glade";
    /**
     * Path to the axilice Address edition interface glade file.
     */
    public static final String AXILICE_EDIT_ADDRESS_GLADE_PATH = "/com/imagos/axilice/client/partners/axiliceaddress.glade";
    
	public static final String AXILICE_EDIT_BANKACCOUNT_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicebankaccount.glade";
	
	public static final String AXILICE_EDIT_PAYMENTMETHOD_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicepaymentmethod.glade";

	public static final String AXILICE_EDIT_DISCOUNT_GLADE_PATH = "/com/imagos/axilice/client/partners/axilicediscount.glade";

	
	
	  /* ----------------------------------------------------------------------
     *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
     *           FOR THE DEPARTMENT ENTITY
     * ---------------------------------------------------------------------- */
	/** Dialog name of the department edition dialog window */
    public static final String EDIT_DEPARTMENT_DIALOG_NAME = "dialogDepartment"; 
    /** Product group code widget's name from the department edition panel */
    public static final String EDIT_DEPARTMENT_CODE_WIDGETNAME = "entryDepartmentId";
    /** Product group description widget's name from the department edition panel */
    public static final String EDIT_DEPARTMENT_NAME_WIDGETNAME = "entryDepartmentName";

	
	
	
    /* ----------------------------------------------------------------------
   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
   *           FOR THE RAPPEL TYPE ENTITY
   * ---------------------------------------------------------------------- */
    public static final String EDIT_RAPPELTYPE_DIALOG_NAME = "dialogRappelType";
    public static final String EDIT_RAPPELTYPE_CODE_WIDGETNAME = "entryRappelTypeId";
    public static final String EDIT_RAPPELTYPE_NAME_WIDGETNAME = "entryRappelTypeName";
	public static final String EDIT_RAPPELTYPE_RAPPELINTERVAL_TABLE_WIDGETNAME = "treeRappelTypeRappelInterval";
	public static final String EDIT_RAPPELTYPE_RAPPELINTERVAL_PANEL_WIDGETNAME = "vboxRappelTypeRappelInterval";
	
	
  /* ----------------------------------------------------------------------
   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
   *           FOR THE PARTNER ENTITY
   * ---------------------------------------------------------------------- */
	
	
  	public static final String EDIT_PARTNER_DIALOG_NAME="dialogPartner";
	public static final String EDIT_PARTNER_CODE_WIDGETNAME = "entryPartnerCode";
	public static final String EDIT_PARTNER_NAME_WIDGETNAME = "entryPartnerName";
	public static final String EDIT_PARTNER_BRANDNAME_WIDGETNAME = "entryPartnerBrandName";
	public static final String EDIT_PARTNER_IDNUMBER_WIDGETNAME = "entryPartnerIdNumber";
	public static final String EDIT_PARTNER_PHONE1_WIDGETNAME = "entryPartnerPhone1";
	public static final String EDIT_PARTNER_PHONE2_WIDGETNAME = "entryPartnerPhone2";
	public static final String EDIT_PARTNER_FAX_WIDGETNAME = "entryPartnerFax";
	public static final String EDIT_PARTNER_EMAIL_WIDGETNAME = "entryPartnerEmail";
	
	public static final String EDIT_PARTNER_PARTNERGROUP_WIDGETNAME = "entryPartnerPartnerGroup";
	public static final String EDIT_PARTNER_SELECT_PARTNERGROUP_BUTTON_WIDGETNAME = "buttonPartnerPartnerGroup";
    
	public static final String EDIT_PARTNER_SELECT_RAPPELTYPE_BUTTON_WIDGETNAME = "buttonPartnerRappelType";
	public static final String EDIT_PARTNER_RAPPELTYPE_WIDGETNAME = "entryPartnerRappelType";
	public static final String EDIT_PARTNER_VENDOR_WIDGETNAME = "entryPartnerVendor";
	public static final String EDIT_PARTNER_SELECT_VENDOR_BUTTON_WIDGETNAME = "buttonPartnerVendor";
	
	public static final String EDIT_PARTNER_SELECT_PAYMENTMETHOD_BUTTON_WIDGETNAME = "buttonPartnerPaymentMethod";
	public static final String EDIT_PARTNER_PAYMENTMETHOD_WIDGETNAME = "entryPartnerPaymentMethod";
	
	public static final String EDIT_PARTNER_BANKACCOUNT_TABLE_WIDGETNAME = "treePartnerBankAccount";
	public static final String EDIT_PARTNER_BANKACCOUNT_PANEL_WIDGETNAME = "vboxPartnerBankAccount";
	
	public static final String EDIT_PARTNER_CONTACT_TABLE_WIDGETNAME = "treePartnerContact";
	public static final String EDIT_PARTNER_CONTACT_PANEL_WIDGETNAME = "vboxPartnerContact";
	
	public static final String EDIT_PARTNER_ADDRESS_TABLE_WIDGETNAME = "treePartnerAddress";
	public static final String EDIT_PARTNER_ADDRESS_PANEL_WIDGETNAME = "vboxPartnerAddress";
	
	
	public static final String EDIT_PARTNER_CURRENCY_WIDGETNAME = "entryPartnerCurrency";
	public static final String EDIT_PARTNER_SELECT_CURRENCY_BUTTON_WIDGETNAME = "buttonPartnerCurrency";
	
	public static final String EDIT_PARTNER_COPIES_WIDGETNAME = "entryPartnerNumCopies";
	public static final String EDIT_PARTNER_MAXRISK_WIDGETNAME = "entryPartnerMaxRisk";
	public static final String EDIT_PARTNER_CURRENTRISK_WIDGETNAME = "entryPartnerCurrentRisk";
	public static final String EDIT_PARTNER_CUSTOMER_WIDGETNAME = "buttonPartnerCustomer";
	public static final String EDIT_PARTNER_EQUIVALENCESURCHARGE_WIDGETNAME = "buttonPartnerEquivalenceSurcharge";
	public static final String EDIT_PARTNER_COMPUTEIDNUMBER_WIDGETNAME = "buttonPartnerComputeIdNumberControl";
	
	public static final String EDIT_PARTNER_NOTEBOOK_WIDGETNAME = "notebookPartner";
	
	public static final String EDIT_PARTNER_TRAZABILITY_PANEL_WIDGETNAME = "voxPartnerTrazability";
	
	public static final String EDIT_PARTNER_PRICELIST_WIDGETNAME = "entryPartnerPriceList";
	
	public static final String EDIT_PARTNER_SELECT_PRICELIST_BUTTON_WIDGETNAME = "buttonPartnerSelectPriceList";
	
	public static final String EDIT_PARTNER_VAT_REGIME_WIDGETNAME = "comboPartnerVatRegime";
	
	public static final String EDIT_PARTNER_PROMPTPAYMENTDISCOUNT_WIDGETNAME = "entryPartnerPromptPaymentDiscount";
	
	public static final String EDIT_PARTNER_FIXEDDISCOUNT_WIDGETNAME = "entryPartnerFixedDiscount";
	
    /* -----------------------------------------------------------------------
     *                          ENTITY NAMES:
     * Constants with the names of the installed entities defined in the 
     * partners module and available for subentity selection dialog 
     * (magnifying glass buttons).
     * ----------------------------------------------------------------------- */
	public static final String AXILICE_ENTITY_CONTACT_ID = "Contact";
	public static final String AXILICE_ENTITY_PARTNERGROUP_ID = "Partners Group";
	public static final String AXILICE_ENTITY_PARTNER_ID = "Partner";
	public static final String AXILICE_ENTITY_DEPARTMENT_ID = "Department";
	public static final String AXILICE_ENTITY_RAPPELTYPE_ID = "Rappel Type";
    public static final String AXILICE_ENTITY_RAPPELINTERVAL_ID = "Rappel Interval";
	public static final String AXILICE_ENTITY_VENDOR_ID = "Vendor";
	public static final String AXILICE_ENTITY_BANKACCOUNT_ID = "Bank Account";
	public static final String AXILICE_ENTITY_ADDRESS_ID = "Address";
	public static final String AXILICE_ENTITY_PAYMENTMETHOD_ID = "Payment Method";
	public static final String AXILICE_ENTITY_DISCOUNT_ID = "Discount";

	//public static final String AXILICE_LOG_EDIT_DEPARTMENT_GLADEPATH = "The department edition interface configuration file has been found at this path: %s";
	//public static final String AXILICE_LOG_EDIT_RAPPELTYPE_GLADEPATH = "The rappel type  edition interface configuration file has been found at this path: %s";
	//public static final String AXILICE_LOG_EDIT_RAPPELINTERVAL_GLADEPATH = "The rappel interval interface configuration file has been found at this path: %s";
	
	
	
	
    /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE RAPPEL INTERVAL ENTITY
	   * ---------------------------------------------------------------------- */
	
    public static final String EDIT_RAPPELINTERVAL_DIALOG_NAME = "dialogRappelInterval";
    public static final String EDIT_RAPPELINTERVAL_CODE_WIDGETNAME = "entryRappelIntervalId";
	public static final String EDIT_RAPPELINTERVAL_LOWERLIMIT_WIDGETNAME = "entryRappelIntervalLowerLimit";
	public static final String EDIT_RAPPELINTERVAL_UPPERLIMIT_WIDGETNAME = "entryRappelIntervalUpperLimit";
	public static final String EDIT_RAPPELINTERVAL_DISCCOUNTRATE_WIDGETNAME = "entryRappelIntervalDisccountRate";
	public static final String EDIT_RAPPELINTERVAL_RAPPELTYPE_WIDGETNAME = "entryRappelIntervalRappelType";
	public static final String EDIT_RAPPELINTERVAL_SELECT_RAPPELTYPE_BUTTON_WIDGETNAME = "buttonRappelIntervalRappelType";

	
	
	
    /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE RATE INTERVAL ENTITY
	   * ---------------------------------------------------------------------- */
	public static final String EDIT_RATE_DIALOG_NAME = "dialogRate";
	public static final String EDIT_RATE_CODE_WIDGETNAME = null;
	public static final String EDIT_RATE_NAME_WIDGETNAME = null;
	
	
    /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE PARTNER group INTERVAL ENTITY
	   * ---------------------------------------------------------------------- */
	public static final String AXILICE_EDIT_PARTNERGROUP_DIALOG_NAME = "dialogPartnerGroup";
	public static final String EDIT_PARTNERGROUP_CODE_WIDGETNAME = "entryPartnerGroupId";
	public static final String EDIT_PARTNERGROUP_DESCRIPTION_WIDGETNAME = "entryPartnerGroupDescription";

	
	
	
	
    /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE VENDOR ENTITY
	   * ---------------------------------------------------------------------- */
	public static final String EDIT_VENDOR_DIALOG_NAME = "dialogVendor";
	public static final String EDIT_VENDOR_CODE_WIDGETNAME = "entryVendorCode";
	public static final String EDIT_VENDOR_NAME_WIDGETNAME = "entryVendorName";
	public static final String EDIT_VENDOR_LASTNAME_WIDGETNAME = "entryVendorLastName";
	public static final String EDIT_VENDOR_IDNUMBER_WIDGETNAME = "entryVendorIdNumber";
	public static final String EDIT_VENDOR_INCOMETAX_WIDGETNAME = "entryVendorIncomeTax";
	public static final String EDIT_VENDOR_SELECT_ADDRESS_BUTTON_WIDGETNAME = "buttonVendorAddress";
	public static final String EDIT_VENDOR_ADDRESS_WIDGETNAME = "entryVendorAddress";
	public static final String EDIT_VENDOR_ADDRESS_PANEL_NAME = "vboxVendorAddress";
	


	
	
    /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE BANK ACCOUNT ENTITY
	   * ---------------------------------------------------------------------- */
	public static final String EDIT_BANKACCOUNT_DIALOG_NAME = "dialogBankAccount";
	public static final String EDIT_BANKACCOUNT_CODE_WIDGETNAME = "entryBankAccountCode";
	public static final String EDIT_BANKACCOUNT_DESCRIPTION_WIDGETNAME = "entryBankAccountDescription";
	public static final String EDIT_BANKACCOUNT_IDBANK_WIDGETNAME = "entryBankAccountIdBank";
	public static final String EDIT_BANKACCOUNT_IDBRANCH_WIDGETNAME = "entryBankAccountIdBranch";
	public static final String EDIT_BANKACCOUNT_CONTROLNUMBER_WIDGETNAME = "entryBankAccountControlNumber";
	public static final String EDIT_BANKACCOUNT_ACCOUNTNUMBER_WIDGETNAME = "entryBankAccountAccountNumber";
	public static final String EDIT_BANKACCOUNT_PARTNER_WIDGETNAME = "entryBankAccountPartner";
	public static final String EDIT_BANKACCOUNT_PARTNER_SELECT_BUTTON_WIDGETNAME = "buttonBankAccountPartner";
	
	
	
	
  /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE PAYMENT METHOD ENTITY
	   * ---------------------------------------------------------------------- */
	
	public static final String EDIT_PAYMENTMETHOD_DIALOG_NAME = "dialogPaymentMethod";
	public static final String EDIT_PAYMENTMETHOD_CODE_WIDGETNAME = "entryPaymentMethodCode";
	public static final String EDIT_PAYMENTMETHOD_DESCRIPTION_WIDGETNAME = "entryPaymentMethodDescription";
	public static final String EDIT_PAYMENTMETHOD_DAYSBETWEENPAYMENTS_WIDGETNAME = "entryPaymentMethodDaysBetweenPayments";
	public static final String EDIT_PAYMENTMETHOD_NUMBERPAYMENTS_WIDGETNAME = "entryPaymentMethodNumberPayments";
	public static final String EDIT_PAYMENTMETHOD_DAYSFIRSTPAYMENT_WIDGETNAME = "entryPaymentMethodDaysFirstPayment";
	public static final String EDIT_PAYMENTMETHOD_CASH_WIDGETNAME = "checkCash";
	public static final String EDIT_PAYMENTMETHOD_BATCH_WIDGETNAME = "checkBatch";



  /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE CONTACT ENTITY
	   * ---------------------------------------------------------------------- */
	public static final String EDIT_CONTACT_DIALOG_NAME = "dialogContact";
	public static final String EDIT_CONTACT_CODE_WIDGETNAME = "entryContactCode";
	public static final String EDIT_CONTACT_NAME_WIDGETNAME = "entryContactName";
	public static final String EDIT_CONTACT_POSITION_WIDGETNAME = "entryContactPosition";
	public static final String EDIT_CONTACT_EMAIL_WIDGETNAME = "entryContactEmail";
	public static final String EDIT_CONTACT_PHONE_WIDGETNAME = "entryContactPhone";
	public static final String EDIT_CONTACT_FAX_WIDGETNAME = "entryContactFax";
	public static final String EDIT_CONTACT_PARTNER_WIDGETNAME = "entryContactPartner";
	public static final String EDIT_CONTACT_PARTNER_SELECT_WIDGETNAME = "buttonContactPartner";
	
	
    /* ----------------------------------------------------------------------
     *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
     *           FOR THE ADDRESS ENTITY
     * ---------------------------------------------------------------------- */
	/** Dialog name of the Address edition dialog window */
    public static final String EDIT_ADDRESS_DIALOG_NAME = "dialogAddress";
    /** Address id widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_ID_WIDGETNAME = "entryAddressIdAddress";
    /** Address description widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_DESCRIPTION_WIDGETNAME = "entryAddressDescription";
    /** Address address widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_ADDRESS_WIDGETNAME = "entryAddressAddress";
    /** Address PO box widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_POBOX_WIDGETNAME = "entryAddressPoBox";
    /** Address invoicing address widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_SHIPPING_WIDGETNAME = "buttonAddressShippingAddress";
    /** Address delivery address widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_BILLING_WIDGETNAME = "buttonAddressBillingAddress";
    /** Address postal code widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_ZIPCODE_WIDGETNAME = "entryAddressZipCode";
    /** Address city widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_CITY_WIDGETNAME = "entryAddressCity";
    /** Address country widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_COUNTRY_WIDGETNAME = "comboAddressCountry";
    /** Address province widget's name from the address edition panel */
    public static final String EDIT_ADDRESS_STATE_WIDGETNAME = "comboAddressState";
    
	public static final String EDIT_ADDRESS_BILLINGADDRESS_WIDGETNAME = "buttonAddressBillingAddress";
	
	public static final String EDIT_ADDRESS_SHIPPINGADDRESS_WIDGETNAME = "buttonAddressShippingAddress";
	
	public static final String EDIT_ADDRESS_VIEW_MAP_BUTTON_WIDGETNAME = "buttonAddressMap";
	
	
	public static final String EDIT_MAP_ZOOM_WIDGETNAME = "scaleAddressMap";
	public static final String AXILICE_MAP_ID = "Map";
	public static final String AXILICE_MAP_DIALOG_NAME="dialogMap";
	public static final String EDIT_MAP_MAP_WIDGETNAME = "canvasAddressMap";
	public static final String EDIT_MAP_OK_BUTTON_WIDGETNAME = "buttonOk";
	public static final String EDIT_VERSION_WIDGETNAME = "entryVersion";
	
	
	  /* ----------------------------------------------------------------------
	   *           CONSTANTS WITH THE NAMES OF THE GUI ELEMENTS
	   *           FOR THE DISCCOUNT ENTITY
	   * ---------------------------------------------------------------------- */
	public static final String EDIT_DISCOUNT_DIALOG_NAME = "dialogDiscount";
	public static final String EDIT_CODE_WIDGETNAME = "entryCode";
	public static final String EDIT_DESCRIPTION_WIDGETNAME = "entryDescription";
	public static final String EDIT_DISCOUNT_LOWERLIMIT_WIDGETNAME = "entryLowerLimit";
	public static final String EDIT_DISCOUNT_UPPERLIMIT_WIDGETNAME = "entryUpperLimit";
	public static final String EDIT_DISCOUNT_RATE_WIDGETNAME = "entryDiscountRate";
	public static final String EDIT_PRODUCT_GROUP_WIDGETNAME = "entryProductGroup";
	public static final String EDIT_PARTNER_GROUP_WIDGETNAME = "entryPartnerGroup";
	public static final String EDIT_PRODUCT_GROUP_SELECT_WIDGETNAME = "buttonProductGroup";
	public static final String EDIT_PARTNER_GROUP_SELECT_WIDGETNAME = "buttonPartnerGroup";
	
	
	
	public static final String AXILICE_PARTNERS_ENTITY_TOOLTIEM_PRINT_NAME = "toolbuttonAxiliceEntityPrint";
	public static final String AXILICE_PARTNERS_ENTITY_PRINT_BUTTON_CLICKED_HANDLER = "on_entity_printButton_clicked";
	public static final String AXILICE_PARTNERS_ENTITY_SELECT_BUTTON_CLICKED_HANDLER = "on_entity_selectButton_clicked";
	public static final String AXILICE_PARTNERS_ENTITY_TOOLITEM_SELECT_NAME="toolbuttonAxiliceEntitySelect";
	
	
	
	public static final String AXILICE_PARTNERS_PARTNER_REPORT = "/com/imagos/axilice/client/reports/axilicepartner.jasper";
	public static final String AXILICE_PARTNERS_GENERIC_REPORT = "/com/imagos/axilice/client/reports/axiliceentityreport.jasper";
	public static final String AXILICE_PARTNERS_ADDRESS_REPORT = "/com/imagos/axilice/client/reports/axiliceaddress.jasper";





	
	


	
	

	
	

	
	

	
	

	
	

	
	
	

	






    



	
	




	








	
	
	

	
	


	
	
	
}
