/*
 * InterfaceExtTable.java
 *
 * $Id: InterfacePartnersErrors.java,v 1.6 2009-07-10 06:12:03 juancarlos Exp $
 */
package com.imagos.axilice.core.partners;

import com.imagos.axilice.core.InterfaceErrors;

/**
 * Public interface with the constant definitions of error codes returned by the
 * warehouse module.
 */
public interface InterfacePartnersErrors extends InterfaceErrors {

	
	// Department queries errors
	public static final int ERR_PARTNERS_DEPARTMENT_NOT_FOUND = 2000;

	// Departments delete messages
	public static final int ERR_PARTNERS_DELETE_DEPARTMENTS_NULL = 2010;
	public static final int MSG_PARTNERS_DELETE_DEPARTMENTS_OK = 2011;
	public static final int ERR_PARTNERS_DELETE_DEPARTMENT = 2012;

	// Departments save messages
	public static final int ERR_PARTNERS_SAVE_DEPARTMENT_NULL = 2013;

	public static final int MSG_PARTNERS_SAVE_DEPARTMENT_OK = 2014;

	public static final int ERR_PARTNERS_SAVE_DEPARTMENT = 2015;
	
	
	
	
	// Rappel type queries errors
	public static final int ERR_PARTNERS_RAPPELTYPE_NOT_FOUND = 2020;

	// Rappel type delete messages
	public static final int ERR_PARTNERS_DELETE_RAPPELTYPE_NULL = 2021;
	public static final int MSG_PARTNERS_DELETE_RAPPELTYPE_OK = 2022;
	public static final int ERR_PARTNERS_DELETE_RAPPELTYPE = 2023;

	// Rappel type save messages
	public static final int ERR_PARTNERS_SAVE_RAPPELTYPE_NULL = 2024;

	public static final int MSG_PARTNERS_SAVE_RAPPELTYPE_OK = 2025;

	public static final int ERR_PARTNERS_SAVE_RAPPELTYPE = 2026;

	public static final int ERR_PARTNERS_RAPPELINTERVAL_NOT_FOUND = 2030;

	public static final int ERR_PARTNERS_SAVE_RAPPELINTERVAL_NULL = 2031;

	public static final int MSG_PARTNERS_SAVE_RAPPELINTERVAL_OK = 2032;

	public static final int ERR_PARTNERS_SAVE_RAPPELINTERVAL = 2033;

	public static final int ERR_PARTNERS_DELETE_RAPPELINTERVAL = 2034;

	public static final int MSG_PARTNERS_DELETE_RAPPELINTERVAL_OK = 2035;

	public static final int ERR_PARTNERS_DELETE_RAPPELINTERVAL_NULL = 2036;

	
	
	
	/**
	 * ERROR CODES FOR GENERIC ENTITY METHODS
	 */
	public static final int ERR_PARTNERS_ENTITY_NOT_FOUND = 3000;

	public static final int ERR_PARTNERS_SAVE_ENTITY_NULL = 3001;

	public static final int MSG_PARTNERS_SAVE_ENTITY_OK = 3002;

	public static final int ERR_PARTNERS_SAVE_ENTITY = 3003;

	public static final int MSG_PARTNERS_DELETE_ENTITY_OK = 3004;

	public static final int ERR_PARTNERS_DELETE_ENTITY = 3005;

	public static final int ERR_PARTNERS_DELETE_ENTITY_NULL = 3006;

	public static final int ERR_PARTNERS_VALIDATE_ENTITY = 4000;

	public static final int MSG_PARTNERS_VALIDATE_ENTITY_OK = 4001;

	public static final int ERR_PARTNERS_EDIT_ENTITY = 4002;

	public static final int MSG_PARTNERS_EDIT_ENTITY_OK = 4003;

	public static final int MSG_PARTNERS_VALIDATE_OK = 4004;

	public static final int MSG_PARTNERS_VALIDATE_ERROR = 4005;

	public static final int MSG_PARTNERS_NIF_VALIDATION_ERROR = 4006;

	public static final int MSG_PARTNERS_EMAIL_VALIDATION_ERROR = 4007;

	public static final int MSG_PARTNERS_PHONE_VALIDATION_ERROR = 4008;

	public static final int ERR_ACCESS_EXCEPTION = 4009;

	
	
	public static final int MSG_PARTNERS_REFRESH_ENTITY_OK = 4010;

	public static final int ERR_PARTNERS_REFRESH_ENTITY = 4011;

	public static final int ERR_PARTNERS_REFRESH_ENTITY_NULL = 4012;

	public static final int MSG_PARTNERS_RISK_VALIDATION_ERROR = 4013;

	public static final int MSG_PARTNERS_DISCOUNT_VALIDATION_ERROR = 4014;



}
