/*
 * InterfaceExtTable.java
 *
 * $Id: InterfaceWarehouseErrors.java,v 1.5 2009-03-06 07:40:21 juancarlos Exp $
 */
package com.imagos.axilice.core.warehouse;

import com.imagos.axilice.core.InterfaceErrors;

/**
 * Public interface with the constant definitions of error codes
 * returned by the warehouse module.
 */
public interface InterfaceWarehouseErrors extends InterfaceErrors {
	// Product validation errors
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_OK = 1000;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_REFERENCE = 1001;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_BARCODE = 1002;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_BARCODE_TYPE = 1003;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_GROUP = 1004;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_DESCRIPTION = 1005;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_PRICE = 1006;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_VAT_TYPE = 1007;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_IMAGE = 1008;
	public static final int ERR_WAREHOUSE_VALIDATION_PRODUCT_ALLOW_NO_STOCK = 1009;
	
	// Product queries errors
	public static final int ERR_WAREHOUSE_PRODUCT_NOT_FOUND = 1100;
	public static final int ERR_WAREHOUSE_PRODUCT_ID_NOT_FOUND = 1101;
	public static final int ERR_WAREHOUSE_PRODUCT_REFERENCE_NOT_FOUND = 1102;
	// Product delete messages
	public static final int MSG_WAREHOUSE_DELETE_PRODUCT_OK = 1110;
	public static final int ERR_WAREHOUSE_DELETE_PRODUCT = 1111;
	public static final int ERR_WAREHOUSE_DELETE_PRODUCT_NULL = 1112;
	public static final int MSG_WAREHOUSE_DELETE_PRODUCT_CANCELLED = 1113;
	
	// Product save messages
	public static final int MSG_WAREHOUSE_SAVE_PRODUCT_OK = 1120;
	public static final int ERR_WAREHOUSE_SAVE_PRODUCT = 1121;
	public static final int ERR_WAREHOUSE_SAVE_PRODUCT_NULL = 1122;
	
	// Product group queries errors
	public static final int ERR_WAREHOUSE_PRODUCTGROUP_NOT_FOUND = 1200;
	public static final int ERR_WAREHOUSE_PRODUCTGROUP_ID_NOT_FOUND = 1201;
	// Product group delete messages
	public static final int MSG_WAREHOUSE_DELETE_PRODUCTGROUP_OK = 1210;
	public static final int ERR_WAREHOUSE_DELETE_PRODUCTGROUP = 1211;
	public static final int ERR_WAREHOUSE_DELETE_PRODUCTGROUP_NULL = 1212;
	public static final int MSG_WAREHOUSE_DELETE_PRODUCTGROUP_CANCELLED = 1213;
	// Product group save messages
	public static final int MSG_WAREHOUSE_SAVE_PRODUCTGROUP_OK = 1220;
	public static final int ERR_WAREHOUSE_SAVE_PRODUCTGROUP = 1221;
	public static final int ERR_WAREHOUSE_SAVE_PRODUCTGROUP_NULL = 1222;
	// Product group next id value messages
	public static final int ERR_WAREHOUSE_NEXT_PRODUCTGROUP = 1225;
	
	// Measure unit queries errors
	public static final int ERR_WAREHOUSE_MEASUREUNIT_NOT_FOUND = 1300;
	public static final int ERR_WAREHOUSE_MEASUREUNIT_ID_NOT_FOUND = 1301;
	// Measure unit delete messages
	public static final int MSG_WAREHOUSE_DELETE_MEASUREUNIT_OK = 1310;
	public static final int ERR_WAREHOUSE_DELETE_MEASUREUNIT = 1311;
	public static final int ERR_WAREHOUSE_DELETE_MEASUREUNIT_NULL = 1312;
	public static final int MSG_WAREHOUSE_DELETE_MEASUREUNIT_CANCELLED = 1313;
	// Measure unit save messages
	public static final int MSG_WAREHOUSE_SAVE_MEASUREUNIT_OK = 1320;
	public static final int ERR_WAREHOUSE_SAVE_MEASUREUNIT = 1321;
	public static final int ERR_WAREHOUSE_SAVE_MEASUREUNIT_NULL = 1322;

	
	
	
	}
