package com.imagos.axilice.core.warehouse;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.List;

import com.imagos.axilice.core.AxiliceException;
import com.imagos.axilice.core.util.OperationResult;

import com.imagos.axilice.core.warehouse.ProductGroupOT;
import com.imagos.axilice.core.warehouse.ProductOT;

public interface WarehouseManager extends Remote {
	public List queryProducts(String fieldId, String value) throws RemoteException, AxiliceException;
	public OperationResult delProduct(Long idProduct) throws RemoteException, AxiliceException;
	public OperationResult delProducts(ArrayList<Long> lSelProducts) throws RemoteException, AxiliceException;
	public OperationResult saveProduct(ProductOT product) throws RemoteException, AxiliceException;
	public ProductOT getProduct(Long idProduct) throws RemoteException, AxiliceException;
	
	public List queryProductGroups(String fieldId, String value) throws RemoteException, AxiliceException;
	public OperationResult delProductGroup(Long idGroup) throws RemoteException, AxiliceException;
	public OperationResult delProductGroups(ArrayList<Long> lSelGroups) throws RemoteException, AxiliceException;
	public OperationResult saveProductGroup(ProductGroupOT group) throws RemoteException, AxiliceException;
	public ProductGroupOT getProductGroup(Long idGroup) throws RemoteException, AxiliceException;
	public long getNextProductGroupId() throws RemoteException, AxiliceException;
	public void resetNextProductGroupId(long idGroup) throws RemoteException, AxiliceException;
	
	public List queryMeasureUnits(String fieldId, String value) throws RemoteException, AxiliceException;
	public OperationResult delMeasureUnit(Long idMeasureUnit) throws RemoteException, AxiliceException;
	public OperationResult delMeasureUnits(ArrayList<Long> lSelMeasureUnits) throws RemoteException, AxiliceException;
	public OperationResult saveMeasureUnit(MeasureUnitOT measureUnit) throws RemoteException, AxiliceException;
	public MeasureUnitOT getMeasureUnit(Long idMeasureUnit) throws RemoteException, AxiliceException;
}