package com.imagos.axilice.server.management;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.ArrayList;
import java.util.List;

import com.imagos.axilice.core.AxiliceException;
import com.imagos.axilice.core.common.BaseVO;
import com.imagos.axilice.core.management.DocumentLineOT;
import com.imagos.axilice.core.management.DocumentOT;
import com.imagos.axilice.core.management.ManagementManager;
import com.imagos.axilice.core.management.MovementOT;
import com.imagos.axilice.core.management.SerialNumberOT;
import com.imagos.axilice.core.util.OperationResult;
import com.imagos.axilice.server.common.bl.CommonBLL;
import com.imagos.axilice.server.management.bl.ManagementBLL;
import com.imagos.axilice.server.util.db.CriteriaBean;
import com.imagos.axilice.core.util.FieldValue;
import com.imagos.axilice.core.warehouse.ProductOT;
import com.imagos.axilice.core.warehouse.StockOT;
import com.imagos.axilice.core.warehouse.WarehouseOT;
import com.imagos.axilice.server.util.db.InterfaceDB;




/**
 * @author Copyright (c) 2007 Imagos 2005 S.L.
 * 
 * <br>
 * <br>
 *         This program is free software: you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation, either version 3 of the License, or (at
 *         your option) any later version. <br/>
 *         This program is distributed in the hope that it will be useful, but
 *         WITHOUT ANY WARRANTY 
 *         <br>without even the implied warranty of
 *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *         General Public License for more details. <br/>
 *         You should have received a copy of the GNU General Public License
 *         along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
public class ManagementManagerImpl extends UnicastRemoteObject implements
		ManagementManager {
	private static final long serialVersionUID = 123456789;

	public ManagementManagerImpl() throws RemoteException {
		super();
	}

	





	public long nextSerialNumber(SerialNumberOT serial) throws RemoteException,AxiliceException{
		
		
		return ManagementBLL.getInstance().nextSerialNumber(serial);
		

	}







	
	public ArrayList<StockOT> getProductStock(ProductOT product, WarehouseOT warehouse) throws AxiliceException, RemoteException {
		return ManagementBLL.getInstance().getProductStock(product, warehouse);
	}







	
	public OperationResult deleteMovements(DocumentLineOT entityData) throws RemoteException, AxiliceException {
//		ArrayList<CriteriaBean > lCriteria=new ArrayList<CriteriaBean>();
//		lCriteria.add(this.buildCriteria("documentLine", entityData));
//		return ManagementBLL.getInstance().delEntities(lCriteria, MovementOT.class);
		
		return null;
	}

	private CriteriaBean buildCriteria(String fieldId, Object value) {
		CriteriaBean result = null;
		Object val = null;
		String op;

		if (value instanceof String) {
			op = InterfaceDB.SQL_OPERATOR_LIKE;
			val = new String("%" + value + "%");
		} else {
			op = InterfaceDB.SQL_OPERATOR_EQUAL;
			val = value;
		}

		// Add the query criteria to the list
		if (fieldId != null && fieldId.length() > 0 && val != null) {
			result = new CriteriaBean(fieldId, val, op, InterfaceDB.LOGIC_OPERATOR_AND, null, null);
		}

		return result;
	}


}
