/*
 * InterfaceDB.java
 *
 * $Id: InterfaceDB.java,v 1.2 2009-06-18 10:38:11 juancarlos Exp $
 *
 * Author: Mario García García - Imagos 2007
 */
package com.imagos.axilice.server.util.db;

/**
 * Public interface with the constant definitions regarding Database generic 
 * utilities. It holds the constant values for SQL operators, logic operators, 
 * normalization functions and others.  
 */
public interface InterfaceDB {
	// SQL operators
	public static final String SQL_OPERATOR_BETWEEN = "BETWEEN";
	public static final String SQL_OPERATOR_IN = "IN";
	public static final String SQL_OPERATOR_EQUAL = "=";
	public static final String SQL_OPERATOR_NOT_EQUAL = "<>";
	public static final String SQL_OPERATOR_GREATER = ">";
	public static final String SQL_OPERATOR_LOWER = "<";
	public static final String SQL_OPERATOR_GREATER_EQUAL = ">=";
	public static final String SQL_OPERATOR_LOWER_EQUAL = "<=";
	public static final String SQL_OPERATOR_LIKE = "LIKE";
	
	//SQL BOOLEAN FUNCTIONS
	public static final String SQL_BOOLEAN_FUNCTION_IS_NULL ="IS NULL";
	public static final String SQL_BOOLEAN_FUNCTION_IS_NOT_NULL ="IS NOT NULL";
	
	// Logic operators
	public static final String LOGIC_OPERATOR_AND = "AND";
	public static final String LOGIC_OPERATOR_OR = "OR";
	// Normalization functions
	public static final String NORMALIZATION_FUNCTION = "PKG_UTIL.NORM_TEXT";
}
